#include <Display/Console.h>
#include <iostream>
#include <iomanip>

// UNIX_CONSOLE macro var is defined in make command

Console::Console() { }

void Console::addSensor(Sensor& sensor)
{
  m_Sensors.push_back(&sensor);
}

void Console::write()
{
  SensorList::iterator idx = m_Sensors.begin();
#ifdef UNIX_CONSOLE
  system("clear"); // clear the console screen
#else
  system("cls"); // for windows console
#endif
  std::cout << "  ### Weather Station ###" << std::endl;
  for(; idx != m_Sensors.end(); ++idx) {
    Sensor* s = *idx;
    std::cout << s->getName() << ": " << std::setw(8) << s->getValue() << "\t" << s->getUnit() << std::endl;
  }
    std::cout << std::endl;
}
